/**
Zeichnet die Levy-C-Kurve

- author: Albert Wiedemann
- version: 1.0
*/
class Kurve
{
    /** Die Turtle */
    private let t: Turtle

    /**
    Legt die Turtle an
    */
    init()
    {
        t = Turtle()
        t.StiftHeben()
        t.PositionSetzen(x: 350, y: 250)
        t.StiftSenken()
    }
    
    /**
	Zeichnet die Levy-C-Kurve mit der gegebenen Tiefe in der angegebenen Farbe.
	- parameters:
		- tiefe: Rekursionstiefe
		- farbe: die Linienfarbe
    */
    func KurveZeichnen(tiefe: Int, farbe: String)
    {
        t.Löschen()
        t.FarbeSetzen(farbe: farbe)
        t.PositionSetzen(x: 350, y: 250)
        SchrittAusführen (länge: 150, tiefe: tiefe)
    }
    
    /**
	Zeichnet die Levy-C-Kurve mit den Tiefen 0 bis 3
    */
    func KurveZeichnen0bis3 ()
    {
        t.Löschen()
        t.FarbeSetzen(farbe: "schwarz")
        t.PositionSetzen(x: 350, y: 250)
        SchrittAusführen (länge: 150, tiefe: 0)
        t.FarbeSetzen(farbe: "rot")
        t.PositionSetzen(x: 350, y: 250)
        SchrittAusführen (länge: 150, tiefe: 1)
        t.FarbeSetzen(farbe: "grün")
        t.PositionSetzen(x: 350, y: 250)
        SchrittAusführen (länge: 150, tiefe: 2)
        t.FarbeSetzen(farbe: "blau")
        t.PositionSetzen(x: 350, y: 250)
        SchrittAusführen (länge: 150, tiefe: 3)
    }
    
    /**
	Zeichnet ein Element der Kurve durch Ausführen des nächsten Rekursionsschrittes
	- parameters:
		- länge: die Linienlänge
        - tiefe: die (restliche) Rekursionstiefe
    */
    private func SchrittAusführen(länge: Double, tiefe: Int)
    {
        if tiefe > 0
        {
            t.Drehen(grad: 45)
            SchrittAusführen(länge: länge * 0.7071, tiefe: tiefe - 1)
            t.Drehen(grad: -90)
            SchrittAusführen(länge: länge * 0.7071, tiefe: tiefe - 1)
            t.Drehen(grad: 45)
        }
        else
        {
            t.Gehen(länge: länge)
        }
    }
}

let k = Kurve()
k.KurveZeichnen0bis3()
