
/**
Erzeugt das Sierpinksi-Dreieck.

- author: Albert Wiedemann
- version: 1.0
*/
class SierpinskiDreieck
{

    /**
	Legt das Grunddreieck an und stößt die Rekursion an
	- parameters:
		- tiefe: Rekursionstiefe
    */
    init(tiefe: Int)
    {
        let basis = Dreieck()
        basis.FarbeSetzen(farbe: "weiß")
        basis.PositionSetzen(x: 400, y: 10)
        basis.GrößeSetzen(breite: 600, höhe: 520)
        SchrittAusführen(x: 400, y: 10, breite: 600, höhe: 520, tiefe: tiefe)
    }
    
    /**
	Ermittelt den Rekursionsschritt
	- parameters:
		- x: x-Position der Dreiecksspitze
		- y: y-Position der Dreiecksspitze
		- breite: die Breite des Umgebungsdreiecks
		- höhe: die Höhe des Umgebungsdreiecks
		- tiefe: restliche Rekursionstiefe
    */
    func SchrittAusführen(x: Int, y: Int, breite: Int, höhe: Int, tiefe: Int)
    {
        if tiefe > 0
        {
            SchrittAusführen(x: x, y: y, breite: breite / 2, höhe: höhe / 2, tiefe: tiefe - 1)
            //Hier die weiteren rekursiven Aufrufe ergänzen
        }
        else
        {
            let basis = Dreieck()
            basis.FarbeSetzen(farbe: "schwarz")
            basis.PositionSetzen(x: x, y: y)
            basis.GrößeSetzen(breite: breite, höhe: höhe)
        }
    }
}

SierpinskiDreieck(tiefe: 4)
