import CoreGraphics

/**
Zeichnet die Hilbert-Kurve

- author: Albert Wiedemann
- version: 1.0
 */
class Hilbert
{
    /** Die Turtle */
    private let t: Turtle
    /** Linienlänge */
    private var länge: Double

    /**
	Legt die Turtle an und startet die Zeichnung
	- parameters:
		- tiefe: Rekursionstiefe
    */
    init(tiefe: Int)
    {
        t = Turtle()
        länge = 400.0 / pow(2.0, Double(tiefe))
        t.StiftHeben()
        t.PositionSetzen(x: Int(länge / 2.0), y: Int(länge / 2.0))
        t.StiftSenken()
        Element(links: false, stufe: tiefe)
    }
    
    /**
	Dreht um 90° nach links oder rechts
	- parameters:
		- links wenn wahr, dann Linksdrehung
    */
    private func Drehen(links: Bool)
    {
        if links
        {
            t.Drehen(grad: 90)
        }
        else
        {
            t.Drehen(grad: -90)
        }
    }
    
    /**
	Zeichnet ein Element der Kurve
	- parameters:
		- links: wenn wahr, dann Linksdrehung
		- stufe: restliche Rekursionstiefe
     */
    private func Element(links: Bool, stufe: Int)
    {
        //Rumpf der Methode ergänzen
    }
}

Hilbert(tiefe: 5)
